#!/usr/bin/php
/* <?php /**/
/*
# 
# licenced under the MIT licence
#
#  Copyright (c)  2008
#
#	version 1.1 - 2008-11-26
#
#	By xorax : www.xorax.info 
#	and Christophe Denuzire : http://christophe.denuziere.org/
#	More informations on http://www.billyboylindien.com/hebergement/script-upgrade-multi-wordpres.html
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice MUST be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
#
#	What the script does ?
#       ----------------------
# 	- Update a liste of wordpress website AUTOMATICALY, just launch, wait, enjoy !
#
#	How to use it ?
#	---------------
#	- Complete the data file with the list aff all your wp sites (ONLY name + path)
#	- Copy this script on your server (yes dedicated if not ... you can try...)
#	- Configure this script (between modify start and end)
#	- chmod +x this script
#	- Launch it
#	- Enjoy
#	- Go working for the time saved !
#
#	How does it works ?
#	-------------------
#	- Dl the latest wp version, unzip it
#	- Backup the files AND the dbs of your wp installs
#	- Copy the new files
#	- Upgrade your wp dbs
#	- More info => Read the code
#
#	Carreful about somethings ?
#	--------------------------
#	- the rights (chmod) of the files. Prefer the apache user than root for execute the script (Yes I've seen you root logged on your server...).
#	You can also add some code for change the chmod and owner:
#	=>>	shell_exec("chown -R user:group $wpdir/");
#	=>>	shell_exec("chmod 775 $wpdir/");
#	
#
#
#	The data file (with list of wordpress path and name):
#	-----------------------------------------------------
#	 Use the following syntax:
#       	[Name]|[AbsolutePathWhithSlashes]
#	 eg:
#	   My_wordpress_super_website|/home/login/mywebsite/wordpress/
#
# 	- One per line
# 	- You can use space but in this case use quotes (yes it will works with but it's EVIL !!)
#	- Do NOT forget the start AND end slash for the path
#	- You MUST have a line return at the end of your file (or a '#')
#
*/

/*
##################
#  Modify start  #
##################
*/

//Vars
$temp = '/tmp'; //Where we stock the temporaries files
$globalbackupdir = '/backup/wordpress_upgrade_backup/'; //Where your save will be stocked
//data file
$datafile = "/backup/wordpress_upgrade_backup/wplist.txt"; //The file with the list of wp is
$datadelimiter = "|"; //The delimiter used in the file

/*
##################
#  Modify end    #
##################
*/

//Download the latest version of wordpress and unzip in the temp dir
shell_exec('wget -O '.$temp.'/wp-latest.tar.gz http://wordpress.org/latest.tar.gz');
shell_exec('tar xzf '.$temp.'/wp-latest.tar.gz -C '.$temp);
shell_exec('rm '.$temp.'/wp-latest.tar.gz');
$temp_wp = $temp . '/wordpress';
shell_exec("rm -Rf $temp_wp/wp-content");


//check if its ok
if (file_exists($temp_wp.'/wp-config-sample.php')) {

	//create dated backup dir
	$backup_dirdate = $globalbackupdir . date('Y-m-d');
	mkdir($backup_dirdate);
	
	//open and fetch datafile
	if($fp = fopen($datafile,"r")) {
	    while ($line = fgets($fp)) {
			$line = trim($line);
			if (substr($line, 0, 1) == '#') {
				continue;
			}
	        $tab=array();
			$tab = explode($datadelimiter, $line);
	        $wpname = trim($tab[0]);
			$wpdir = rtrim(trim($tab[1]), '/');
			
			echo "####################################\nUpgrade $wpname go gO GO\n####################################\n";
			//do the backup 
			if (file_exists($wpdir . '/wp-config.php')) {
				//create backup dir
				$backup_dir = $backup_dirdate . '/' . $wpname .'_'.substr(md5(time()), 0, 8);
				mkdir($backup_dir);
				
				//Mysql backup
				$conf = file_get_contents($wpdir.'/wp-config.php');
				$conf = preg_replace('#^.*require.*$#m', '', $conf);
				$conf = preg_replace('#<\?php|\?>#', '', $conf);
				eval($conf);
				echo "saving database ...\n";
				$ret = shell_exec('mysqldump --host='.DB_HOST.' --user='.DB_USER.' --pass='.DB_PASSWORD.' '.DB_NAME.' > '.$backup_dir.'/sql_backup.sql');
				if (preg_match('#error#i', $ret)) {
					die ('database cannot be saved');
				}
				echo "database saved\n";
				
				//files backup
				echo "saving wp files ...\n";
				shell_exec("tar czf $backup_dir/files_backup.tar.gz $wpdir/"); // You can add  --exclude 'wp-content/*'  for not backup the wp-content directory (and save diskspace) 
				echo "wp files saved\n";
				
				//Copie new files
				echo "Copying news files ...\n";
				shell_exec("cp -Rf $temp_wp/* $wpdir/");
				
				//Upgrade the DB
				echo "upgrade database ...\n";
				$upgrade_script = "<?php require ".$wpdir."/wpload.php'; require_once(ABSPATH.'wp-admin/includes/upgrade.php'); wp_upgrade(); ?>";
				$upgrade_script = 'echo "'.$upgrade_script.'" | php';
				shell_exec($upgrade_script);
				echo "wp $wpname upgraded. enjoy !\n";
			}
			else {
				die ("$wpdir is not a valid wordpress directory\n".$usage);
			}
	    }
	    /* fermeture fichier */
	    fclose ($fp);
	} else {
	    echo "Cannot open the file";
	}
shell_exec("rm -Rf $temp_wp/");
}
else {
	die("error: cannot view wp in $temp_wp\n");
}
